std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor > Class Template Reference
Experimental » Optional values

`#include <optional>`

Inheritance diagram for std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >:
[legend]

## Public Member Functions

| _Optional_base (_Optional_base &&__other) noexcept(is_nothrow_move_constructible< _Tp >())
| _Optional_base (const _Optional_base &__other)
template<typename... _Args>
constexpr | _Optional_base (in_place_t, _Args &&... __args)
template<typename _Up , typename... _Args, enable_if_t< is_constructible< _Tp, initializer_list< _Up > &, _Args &&... >::value, int > ...>
constexpr | _Optional_base (in_place_t, initializer_list< _Up > __il, _Args &&... __args)
constexpr | _Optional_base (nullopt_t) noexcept
_Optional_base & | operator= (_Optional_base &&__other) noexcept(__and_< is_nothrow_move_constructible< _Tp >, is_nothrow_move_assignable< _Tp > >())
_Optional_base & | operator= (const _Optional_base &__other)

## Protected Member Functions

template<typename... _Args>
void | _M_construct (_Args &&... __args) noexcept(is_nothrow_constructible< _Stored_type, _Args... >())
void | _M_destruct ()
constexpr const _Tp & | _M_get () const noexcept
constexpr _Tp & | _M_get () noexcept
constexpr bool | _M_is_engaged () const noexcept
void | _M_reset ()

## Detailed Description

template<typename _Tp, bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>
class std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >

Class template that holds the necessary state for Optional values and that has the responsibility for construction and the special members.

Such a separate base class template is necessary in order to conditionally enable the special members (e.g. copy/move constructors). Note that this means that _Optional_base implements the functionality for copy and move assignment, but not for converting assignment.

See also
  optional, _Enable_special_members

Definition at line 202 of file optional.

## Constructor & Destructor Documentation

## _Optional_base() [1/6]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_Optional_base | ( |  | ) |

inline constexpr noexcept

Definition at line 214 of file optional.

## _Optional_base() [2/6]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_Optional_base | ( | nullopt_t |  | ) |

inline constexpr noexcept

Definition at line 217 of file optional.

## _Optional_base() [3/6]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>
template<typename... _Args>

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_Optional_base | ( | in_place_t | ,
|  | _Args &&... | __args
| ) |  |

inline explicit constexpr

Definition at line 222 of file optional.

## _Optional_base() [4/6]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>
template<typename _Up , typename... _Args, enable_if_t< is_constructible< _Tp, initializer_list< _Up > &, _Args &&... >::value, int > ...>

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_Optional_base | ( | in_place_t | ,
|  | initializer_list< _Up > | __il,
|  | _Args &&... | __args
| ) |  |

inline explicit constexpr

Definition at line 230 of file optional.

## _Optional_base() [5/6]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_Optional_base | ( | const _Optional_base< _Tp, _ShouldProvideDestructor > & | __other | ) |

inline

Definition at line 237 of file optional.

## _Optional_base() [6/6]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_Optional_base | ( | _Optional_base< _Tp, _ShouldProvideDestructor > && | __other | ) |

inline noexcept

Definition at line 243 of file optional.

## ~_Optional_base()

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::~_Optional_base | ( |  | ) |

inline

Definition at line 285 of file optional.

## Member Function Documentation

## _M_construct()

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>
template<typename... _Args>

void std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_construct | ( | _Args &&... | __args | ) |

inline protected noexcept

Definition at line 310 of file optional.

## _M_destruct()

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

void std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_destruct | ( |  | ) |

inline protected

Definition at line 319 of file optional.

## _M_get() [1/2]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

constexpr const _Tp & std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_get | ( |  | ) | const

inline constexpr protected noexcept

Definition at line 303 of file optional.

## _M_get() [2/2]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

constexpr _Tp & std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_get | ( |  | ) |

inline constexpr protected noexcept

Definition at line 299 of file optional.

## _M_is_engaged()

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

constexpr bool std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_is_engaged | ( |  | ) | const

inline constexpr protected noexcept

Definition at line 294 of file optional.

## _M_reset()

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

void std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_reset | ( |  | ) |

inline protected

Definition at line 327 of file optional.

## operator=() [1/2]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

_Optional_base & std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::operator= | ( | _Optional_base< _Tp, _ShouldProvideDestructor > && | __other | ) |

inline noexcept

Definition at line 268 of file optional.

## operator=() [2/2]

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

_Optional_base & std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::operator= | ( | const _Optional_base< _Tp, _ShouldProvideDestructor > & | __other | ) |

inline

Definition at line 252 of file optional.

## Member Data Documentation

## _M_empty

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

_Empty_byte std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_empty

Definition at line 336 of file optional.

## _M_payload

template<typename _Tp , bool _ShouldProvideDestructor = !is_trivially_destructible<_Tp>::value>

_Stored_type std::experimental::fundamentals_v1::_Optional_base< _Tp, _ShouldProvideDestructor >::_M_payload

Definition at line 337 of file optional.

The documentation for this class was generated from the following file:

- optional